import logging
from odoo import http
from odoo.addons.website_sale.controllers.main import WebsiteSale
from odoo.addons.http_routing.models.ir_http import slug
from odoo.addons.website.models.ir_http import sitemap_qs2dom
from odoo.http import route, request
from odoo.addons.website.controllers.main import QueryURL
from odoo import _

_logger = logging.getLogger(__name__)


# from odoo import http
#
# class Custom404Controller(http.Controller):
#
#     @http.route('/category/page/false', type='http', auth='public', website=True)
#     def handle_404(self):
#         return request.render('http_routing.404')


class Website_Sale(WebsiteSale):

    def sitemap_shop(env, rule, qs):
        if not qs or qs.lower() in '/shop':
            yield {'loc': '/shop'}

        Category = env['product.public.category']
        dom = sitemap_qs2dom(qs, '/shop/category', Category._rec_name)
        dom += env['website'].get_current_website().website_domain()
        for cat in Category.search(dom):
            loc = request.website.get_seo_category_url(cat)
            if not qs or qs.lower() in loc:
                yield {'loc': loc}

    @route(sitemap=sitemap_shop)
    def shop(self, page=0, category=None, search='', ppg=False, **post):

        result = super(Website_Sale, self).shop(page=page, category=category, search=search, ppg=ppg, **post)
        qcontext = result.qcontext
        url = "/shop"
        website_id = request.env['website'].get_current_website()
        if category:
            category = request.env['product.public.category'].search([('id', '=', int(category))], limit=1)
            if category:
               url = request.website.get_seo_category_url(category)
        if not ppg:
            ppg = website_id.shop_ppg or 20

        if qcontext.get("search_count"):
            pager = request.website.pager(url=url, total=qcontext.get("search_count"), page=page, step=ppg, scope=7, url_args=post)
            def old_get_url(page_url):
                url = '/'.join(page_url.split('/')[:-2])
                num = page_url.split('/')[-1]
                return '%s?page=%s' % (url, num)
            # pager['pages'] = [{'url': get_url(page_item['url']), 'num': page_item['num']} for page_item in pager['pages']]
            def get_url(page):
                _url = url
                if page and search:
                    if page>1:
                        _url = "%s?page=%s&search=%s" % (url, page,search)
                    else:
                        _url = "%s?&search=%s"%(url, search)
                if page and not search:
                    if page>1:
                        _url = "%s?page=%s" % (url, page)
                elif not page and search:
                    _url = "%s?&search=%s"%(url,search)
                return _url
            pager['page'] = {'url': get_url(pager['page']['num']), 'num': pager['page']['num']}
            pager['page_start'] = {'url': get_url(pager['page_start']['num']), 'num': pager['page_start']['num']}
            pager['page_previous'] = {'url': get_url(pager['page_previous']['num']), 'num': pager['page_previous']['num']}
            pager['page_next'] = {'url': get_url(pager['page_next']['num']), 'num': pager['page_next']['num']}
            pager['page_end'] = {'url': get_url(pager['page_end']['num']), 'num': pager['page_end']['num']}
            pager['page_last'] = {'url': get_url(pager['page_last']['num']), 'num': pager['page_last']['num']}
            pager['pages'] = [{'url': get_url(page_item['num']), 'num': page_item['num']} for page_item in pager['pages']]
            result.qcontext.update(pager=pager)
        result.qcontext.get('keep',QueryURL()).args={}
        argss = http.request.httprequest.args



        # result.qcontext.update(pager=pager)
        return result

    @route()
    def add_product(self, name=None, category=None, **post):
        product = request.env['product.product'].create({
            'name': name or _("New Product"),
            'public_categ_ids': category,
            'website_id': request.website.id,
        })
        return "%s?enable_editor=1" % request.website.get_seo_product_url(product.product_tmpl_id)
