# -*- coding: utf-8 -*-
# Part of Softhealer Technologies.
from odoo import fields, models
from odoo.exceptions import ValidationError

class ShMessageWizard(models.TransientModel):
    _name = "sh.message.wizard"
    _description = "Message wizard to display warnings, alert ,success messages"

    def get_default(self):
        if self.env.context.get("message", False):
            return self.env.context.get("message")
        return False

    name = fields.Text(string="Message", readonly=True, default=get_default)

    def genrated_message(self,text):
        try:
            view = self.env.ref('website_seo_url_rewrite.sh_message_wizard')
            view_id = view and view.id or False
            context = dict(self._context or {})
            context['message'] = text
            return {
                'name': context.get('name','Success'),
                'domain': [('partner_id', '=', self.id)],
                'res_model': 'sh.message.wizard',
                'type': 'ir.actions.act_window',
                'view_type': 'form',
                'view_mode': 'tree,form',
                'views':[(view_id,'form')],
                'view_id':view_id,
                'target':'new',
                'context':context,
            }
        except Exception as ex:
            raise ValidationError(ex)